#include <qdialog.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qbrush.h>
#include <qlcdnum.h>
#include <qradiobt.h>
#include <qlined.h>
#include <qlistbox.h>
#include <qtimer.h>
#include "rules.h"
#include "connect.h"
class OptDial : public QDialog {
 Q_OBJECT;
public:
 OptDial(int*,QWidget* parent=0,const char* name=0);
 QButtonGroup *bg;
 QRadioButton *rb1,*rb2;
 QPushButton *quit,*ok;
 QLineEdit *le,*letime;
 QLabel *min;
 int *p;
 char txt[200];
public slots: 
 void beclient(int);
 void chktime(const char*);
};

class PromoWindow : public QDialog
{
 Q_OBJECT;
public:
 PromoWindow(int color, QWidget *parent=0, const char *name="Promotion");
public slots:
 void knight();
 void bishop();
 void rook();
 void queen();
public: 
 QPushButton *but[4];
};

class Uhr:public QLCDNumber{
 Q_OBJECT
public:
 Uhr(int,QWidget*,const char*);
 void reset(int);
public slots:
 void change();
 void stop();
 void start();
signals:
 void over(int);
private:
 void calc();
 int startsec,cur,isact;
 char dis[20];
 QTimer *timer;
};

class MyWidget : public QWidget
{
 Q_OBJECT
public:
    MyWidget( QWidget *parent=0, const char *name=0 );
    void drawboard(bool=true);
    void drawfield(FIELD *feld,bool=true);
    void special(FIELD *,FIELD *);
    void promote(FIELD *,bool);
    void translate(FIELD *f,char *,int);
    void syst_mes(const char *);
    void newgame(int);
    void initboard();
    void displaymove(FIELD *);
    int playtime;
    Socke *socke;
public slots:
    void amconnected();
    void sendchat();
    void receive(int);
    void timeover(int);
    void res_pressed();
    void draw_pressed();
    void newgm_pressed();
protected:
    void paintEvent(QPaintEvent *);
    void mousePressEvent(QMouseEvent *);
    void mouseReleaseEvent(QMouseEvent *);
private:
    Uhr *mylcd,*oplcd;
    QLCDNumber *sc[2];
    QLineEdit *le;
    QListBox *lb;
    QLabel *ml;
    QCursor *curs;
    QBrush whitebrush,blackbrush,*brush;
    QPushButton *quit,*resign,*draw,*newgm;
    int gamestate,touched_piece;
    FIELD *touched_field;
};

