#include <stdio.h>
#include "chess.h"


Uhr::Uhr(int sec,QWidget* parent,const char *name)
   :QLCDNumber(7,parent,name)
{
 isact=0;
 timer=new QTimer(this);
 timer->start(1000);
 connect(timer,SIGNAL(timeout()),SLOT(change()));
 cur=startsec=sec;
 calc();
 display(dis);
} 
void Uhr::reset(int sec){
 cur=startsec=sec;
 calc();
 display(dis);
// repaint();
};
void Uhr::change(){
 if (!isact) return;
 cur--;
 if (!cur) {
  int i=strcmp(name(),"mytime");
  if (i) i=1; else i=2;
  emit over(i);
 } 
 calc();
 display(dis);
// repaint();
};
void Uhr::stop(){
 setSegmentStyle(QLCDNumber::Outline);
 isact=0;
 setBackgroundColor(lightGray);
// setEnabled(FALSE);
// repaint();
}
void Uhr::start(){
 setSegmentStyle(QLCDNumber::Flat);
 isact=1;
// setEnabled(true);
 setBackgroundColor(white);
// repaint();
} 
void Uhr::calc(){
 int hou,min,sec,sav=cur;
 hou=sav/3600;
 sav%=3600;
 min=sav/60;
 sec=sav%60;
 sprintf(dis,"%d:%02d:%02d",hou,min,sec);
};
