#include <errno.h>       /* obligatory includes */
#include <sys/types.h>
#include <strings.h>
#include <arpa/nameser.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <qapp.h>
#include <resolv.h>
#include "connect.h"
#define PORTNUM 5000 /* random port number, we need something */

#ifdef sun
extern "C" int gethostname(char *name, int namelen);
#endif

Socke::Socke(char* server,QObject *parent=0,const char *name=0)
      :QObject(parent,name)
{ socke=0;
  bzero(conn_name,200);
  call_socket(server,PORTNUM);
}

Socke::Socke(QObject *parent=0,const char *name=0)
      :QObject(parent,name)
{ socke=0; 
  bzero(conn_name,200);
 ws=make_sock(PORTNUM);
 if (ws==-1) {perror("Can't bind to socket");qApp->quit(); exit(-1);}
 testnot=new QSocketNotifier(ws,QSocketNotifier::Read);
 connect(testnot,SIGNAL(activated(int)),SLOT(canaccept()));
}

void Socke::sendconn(){
 instnot();
 emit connected();
}

void Socke::instnot(){
 readnot=new QSocketNotifier(socke,QSocketNotifier::Read);
 errnot=new QSocketNotifier(socke,QSocketNotifier::Exception);
 connect(readnot,SIGNAL(activated(int)),SLOT(readdata(int)));
 connect(errnot,SIGNAL(activated(int)),SLOT(sockerror()));
}
int Socke::getsock(){return socke;}

void Socke::readdata(int s){
 readnot->setEnabled(FALSE);
 receivemove();
}
void Socke::sockerror(){
 fprintf(stderr,"unknown socket error\n");
 qApp->quit();
}
int Socke::call_socket(const char *hostname, int portnum){
    struct hostent     *hp;
    int a,s,j;

    if ((hp= gethostbyname(hostname)) == NULL) { /* do we know the host's */
      fprintf(stderr,"%s: Name lookup Error\n",hostname);
      qApp->quit();
      return(-1);                                /* no */
    }

    bzero(&sa,sizeof(sa));
    bcopy(hp->h_addr,(char *)&sa.sin_addr,hp->h_length); /* set address */
    sa.sin_family= hp->h_addrtype;
    sa.sin_port= htons((u_short)portnum);

    if ((s= socket(hp->h_addrtype,SOCK_STREAM,0)) < 0)   /* get socket */
      return(-1);
    if (j=::connect(s,(struct sockaddr *)&sa,sizeof sa) < 0) {                  /* connect */
      ::close(s);
      perror(hostname);
      qApp->quit();
      exit(-1);
    }
    hp=gethostbyaddr((char *)&sa.sin_addr,sizeof(sa.sin_addr),AF_INET);
    if (hp) strcpy(conn_name,hp->h_name);
     else (conn_name,hostname);
    socke=s;
    return(s);
  }

int Socke::make_sock(int portnum) {
    char   myname[200];
    struct hostent *hp;
    int i;                  /* size of address */

    bzero(&sa,sizeof(struct sockaddr));      /* clear our address */
    gethostname(myname,200);            /* who are we? */
    hp= gethostbyname(myname);                  /* get our address info */
    if (hp == NULL)                             /* we don't exist !? */
      return(-1);
    sa.sin_family= AF_INET;              /* this is our host address */
    sa.sin_port= htons(portnum);                /* this is our port number */
    if ((ws= socket(AF_INET,SOCK_STREAM,0)) < 0) /* create socket */
      return(-1);
    i=1;  
    if (bind(ws,(struct sockaddr *) &sa,sizeof sa) < 0) {
      close(ws);
//      ::unlink(s);
      return(-1);                               /* bind address to socket */
    }
    if (listen(ws,0)==-1){                               /* max # of queued connects */
     printf("listen: %s\n",strerror(errno));
     close(ws);
     return(-1);
    }
    i=sizeof(sa);
    return ws;
}
void Socke::canaccept(){
int t1,i;
char ad[33];
unsigned long j,iad[4]={0,0,0,0};
    struct hostent *hp;
    i=sizeof(sa);
    if ((t1 = ::accept(ws,(struct sockaddr *)&sa,&i)) < 0)   /* accept connection if there is one */
     {perror("accept");
      exit(-1);}
    close(ws);  
    socke=t1;
    testnot->setEnabled(FALSE);
    j=ntohl(sa.sin_addr.s_addr);
    for (int k=3;k>=0;k--){
     i=0;
     while ((i<<8*k)<=j) i++;
     iad[k]=i-1;
     j-=(i-1)<<8*k;
    }
    hp=gethostbyaddr((char *)&sa.sin_addr,sizeof(sa.sin_addr),AF_INET);
    if (hp) strcpy(conn_name,hp->h_name);
     else sprintf(conn_name,"%d.%d.%d.%d",iad[3],iad[2],iad[1],iad[0]);
    sendconn();
}

int Socke::serverconnect(){
 int t;
 t=make_sock(PORTNUM);
 if (t==-1) {perror ("Connect");exit(-1);}
 return 1;
}
int Socke::clientconnect(char *n){
 int t;
 t=call_socket(n,PORTNUM);
 if (t==-1) {perror ("Connect");exit(-1);}
 return 1;
}
int Socke::sendmove(char* chat){
 write(socke,chat,::strlen(chat)+1);
}
int Socke::receivemove(){
int i=0,j=0;
const int n=256;
 inmove[0]=0;
 j=read(socke,(void *)(inmove),1); 
 if ((!j) || (j==-1) || (!inmove[0]))  {emit msg(0);return 0;}
 i=0;
 do {
    i++; 
    j=read(socke,(void *)(inmove+i),1);
   } while ((inmove[i]) && (i<MAXCHAT));
 emit msg(1);
}

void Socke::close_socket(){
 close(socke);
}



