#include <stdlib.h>
#include "rules.h"
int board[8][8],specialmove,opcolor,oldboard[8][8],oldspecial;
int ret1,i,j,status=0,ende=0;
const int BOARD[8][8]={
 { ROOK | WHITEPIECE, KNIGHT | WHITEPIECE,BISHOP | WHITEPIECE, QUEEN | WHITEPIECE,KING | WHITEPIECE, BISHOP | WHITEPIECE,KNIGHT | WHITEPIECE,ROOK | WHITEPIECE},
 { PAWN | WHITEPIECE, PAWN   | WHITEPIECE,PAWN   | WHITEPIECE, PAWN  | WHITEPIECE,PAWN | WHITEPIECE, PAWN   | WHITEPIECE,PAWN   | WHITEPIECE,PAWN | WHITEPIECE},
 { 0                  ,0                   ,0                  ,0                 ,0                 ,0                   ,0                  ,0              },
 { 0                  ,0                   ,0                  ,0                 ,0                 ,0                   ,0                  ,0              },
 { 0                  ,0                   ,0                  ,0                 ,0                 ,0                   ,0                  ,0              },
 { 0                  ,0                   ,0                  ,0                 ,0                 ,0                   ,0                  ,0              },
 { PAWN | BLACKPIECE, PAWN   | BLACKPIECE,PAWN   | BLACKPIECE, PAWN  | BLACKPIECE,PAWN | BLACKPIECE, PAWN   | BLACKPIECE,PAWN   | BLACKPIECE,PAWN | BLACKPIECE},
 { ROOK | BLACKPIECE, KNIGHT | BLACKPIECE,BISHOP | BLACKPIECE, QUEEN | BLACKPIECE,KING | BLACKPIECE, BISHOP | BLACKPIECE,KNIGHT | BLACKPIECE,ROOK | BLACKPIECE}
};
FIELD ff1,ff2,ff3;

typedef struct{
 int piece;
 FIELD f1;
 FIELD  f2;
 int special;
 } MOVELIST;

MOVELIST movelist[800];

int mycolor,mcount=0;

void swapcolor(){
 if (mycolor==WHITEPIECE) mycolor<<=1; else mycolor>>=1;
}

void move(FIELD *f1,FIELD *f2){
 board[f2->x][f2->y]=board[f1->x][f1->y];
 board[f1->x][f1->y]=0;
 switch (specialmove) {
  case ENPASSENT:   board[f2->x][f1->y]=0;break;
  case SHORTCASTLE: board[f1->x+1][f1->y]=board[7][f1->y];
                    board[7][f1->y]=0;
                    break;
  case LONGCASTLE:  board[f1->x-1][f1->y]=board[0][f1->y];
                    board[0][f1->y]=0;
                    break;
 }
}

void update_list(FIELD *f1,FIELD *f2){
 movelist[mcount].piece=(board[f1->x][f1->y]);
 movelist[mcount].special=specialmove;
 memcpy(&movelist[mcount].f1,f1,sizeof(FIELD));
 memcpy(&movelist[mcount].f2,f2,sizeof(FIELD));
 mcount++;
}

int pawn(FIELD *f1,FIELD *f2){
 int x,y,c,y1;
 x=abs(f2->x-f1->x);
 y=(f2->y-f1->y);
 c=(board[f1->x][f1->y] & BLACKPIECE);
 if (c) {y=-y;y1=-1;}else y1=1;
 if (y<0) return 0;      //backward move
 switch (x) {
  case 0:if ((y==1) && (!board[f2->x][f2->y])) {//advance one field
          if ((c) && (f2->y==0)) specialmove=PROMOTE;
          if ((!c) && (f2->y==7)) specialmove=PROMOTE;
          return 1;
         }
         if ((y==2) && (!board[f1->x][f1->y+y1]) && (!board[f1->x][f1->y+2*y1])) {
          if ((c) && (f1->y==6)) return 1;//advance two fields (black)
          if ((!c) && (f1->y==1)) return 1;//advance two fields (white)
         } break;
  case 1:if (y!=1) return 0;
         if (board[f2->x][f2->y]) {//take piece
          if ((c) && (f2->y==0)) specialmove=PROMOTE;
          if ((!c) && (f2->y==7)) specialmove=PROMOTE;
          return 1;
         }
         //en passent
         if (!(movelist[mcount-1].piece & PAWN)) return 0; //no pawn was moved
         if (movelist[mcount-1].f1.x!=f2->x) return 0; //not the right pawn was moved
         if ((c) && (f1->y==3)) { //black
             if ((movelist[mcount-1].f1.y==1) && (movelist[mcount-1].f2.y==3))
              {specialmove=ENPASSENT;return 1;}
             }
         if ((!c) && (f1->y==4)) { //white
             if ((movelist[mcount-1].f1.y==6) && (movelist[mcount-1].f2.y==4))
              {specialmove=ENPASSENT;return 1;}
             }
  default:return 0;
 }
 return 0;
}

int knight(FIELD *f1,FIELD *f2){
 int x,y;
 x=abs(f1->x-f2->x);
 y=abs(f1->y-f2->y);
 if (((x==2) && (y==1)) || ((x==1) && (y==2))) return 1;
 return 0;
}

int bishop(FIELD *f1,FIELD *f2){
 int x,y,i,j,xs,ys;
 x=f2->x-f1->x;
 y=f2->y-f1->y;
 if (abs(x)!=abs(y)) return 0;
 if (x<0) xs=-1;else xs=1;
 if (y<0) ys=-1;else ys=1;
 for (i=xs,j=ys;(f1->x+i!=f2->x);i+=xs,j+=ys)
  if (board[i+f1->x][j+f1->y]) return 0;
//  if
 return 1;
}

int rook(FIELD *f1,FIELD *f2){
 int x,y,i,j,xs=0,ys=0;
 x=f2->x-f1->x;
 y=f2->y-f1->y;
 if ((x)&&(y)) return 0;
 if (x) {if (x<0) xs=-1;else xs=1;}
 if (y) {if (y<0) ys=-1;else ys=1;}
 for (i=xs,j=ys;(!((f1->x+i==f2->x) && (f1->y+j==f2->y)));i+=xs,j+=ys)
  if (board[i+f1->x][j+f1->y]) return 0;
 return 1;
}

int queen(FIELD *f1,FIELD *f2){
 return (rook(f1,f2)||bishop(f1,f2));
}

int king(FIELD *f1,FIELD *f2){
 int i,x,y,y1;

 x=f2->x-f1->x;
 y=abs(f1->y-f2->y);
 if ((abs(x)<=1) && (y<=1)) return 1;
 if (abs(x)!=2) return 0;
 if (status==CHECK) return 0;
 if (f1->x!=4) return 0;
 if (f1->y!=f2->y) return 0;
 if (board[f1->x][f1->y] & WHITEPIECE) y1=0;else y1=7;
 if (y1!=f1->y) return 0;
 if (x<0) {
  if (!(board[0][y1] & ROOK)) return 0;     //rook not present
  if (!(board[0][y1] & board[4][y1])) return 0; //rook has different color
  for (i=f1->x-1;i>0;i--)
   if (board[i][y1]) return 0;                //intermediate piece
  for (i=0;i<mcount;i++) {
   if (movelist[i].piece==board[4][y1]) return 0; //king has already been moved
   if ((movelist[i].f1.x==0)&& (movelist[i].f1.y==y1)) return 0; //rook has already been moved
  }
  specialmove=LONGCASTLE;
  return 1;
 } else {
  if (!(board[7][y1] & ROOK)) return 0;
  if (!(board[7][y1] & board[4][y1])) return 0;
  for (i=f1->x+1;i<7;i++)
   if (board[i][y1]) return 0;
  for (i=0;i<mcount;i++) {
   if (movelist[i].piece==board[4][y1]) return 0;
   if ((movelist[i].f1.x==7)&& (movelist[i].f1.y==y1)) return 0;
  }
  specialmove=SHORTCASTLE;
  return 1;
 }
 return 0;
}

int islegal(FIELD *f1,FIELD *f2,int myturn){

 if (mycolor==WHITEPIECE) opcolor=BLACKPIECE; else opcolor=WHITEPIECE;
 if (!memcmp(f1,f2,sizeof(FIELD))) return 0;   //same fields
 specialmove=0;
 if (myturn) {
  if ((board[f1->x][f1->y] & COLORS)!=mycolor) //piece has not my color
   return 0;
 }
 if ((board[f1->x][f1->y] & COLORS)==(board[f2->x][f2->y] & COLORS)) return 0; //can't take my own peace
 switch(board[f1->x][f1->y] & PIECES){
  case PAWN  :if (!pawn  (f1,f2)) return 0;break;
  case KNIGHT:if (!knight(f1,f2)) return 0;break;
  case BISHOP:if (!bishop(f1,f2)) return 0;break;
  case ROOK  :if (!rook  (f1,f2)) return 0;break;
  case QUEEN :if (!queen (f1,f2)) return 0;break;
  case KING  :if (!king  (f1,f2)) return 0;break;
 }
 if (myturn) {
  ret1=0;
  if (specialmove & (LONGCASTLE|SHORTCASTLE))
   {ff3.x=(f1->x+f2->x)/2;ff3.y=f1->y;}
  memcpy(oldboard,board,sizeof(board));  //save board
  oldspecial=specialmove;                //save special flag
  move(f1,f2);                         //simulate move
  update_list(f1,f2);
  for (i=0;i<8;i++)
   for (j=0;j<8;j++)
    if ((board[i][j])==(mycolor|KING)){ff2.x=i;ff2.y=j;break;} //find my king
  for (i=0;i<8;i++) {
   for (j=0;j<8;j++){
    if (!(board[i][j] & opcolor)) continue;
    ff1.x=i;ff1.y=j;                          // find op's pieces
    if ((ret1=islegal(&ff1,&ff2,OPTURN))) break; //do they check?
    if ((oldspecial & (LONGCASTLE|SHORTCASTLE)) &&
    (ret1=islegal(&ff1,&ff3,OPTURN))) break; //bedrohtes Feld bei Castling?
   }
   if (ret1) break;
  }
  specialmove=oldspecial;
  memcpy(board,oldboard,sizeof(board));
  mcount--;
  if (ret1) {
   swapcolor();
   return 0;
  }
 }
 update_list(f1,f2);
 swapcolor();
 return 1;
}


int is_end(){
FIELD fr1,fr2;
 int oldmcount=mcount,i,j,ii,jj,retval=0,retval1=0;

 if (status==RESIGN) return 0;
 if (mycolor==WHITEPIECE) opcolor=BLACKPIECE; else opcolor=WHITEPIECE;
 for (i=0;i<8;i++)
  for (j=0;j<8;j++)
   if ((board[i][j])==(mycolor|KING))
   {fr2.x=i;fr2.y=j;break;} //find my king
 for (i=0;i<8;i++){
  for (j=0;j<8;j++){
   if (!(board[i][j] & opcolor)) continue;
   fr1.x=i;fr1.y=j;                          // find op's pieces
   switch(board[i][j] & PIECES){
    case PAWN  :retval=pawn  (&fr1,&fr2);break;
    case KNIGHT:retval=knight(&fr1,&fr2);break;
    case BISHOP:retval=bishop(&fr1,&fr2);break;
    case ROOK  :retval=rook  (&fr1,&fr2);break;
    case QUEEN :retval=queen (&fr1,&fr2);break;
    case KING  :retval=king  (&fr1,&fr2);break;
   }
   if (retval) break;
  }
  if (retval) break;
 }
 if (retval) status=CHECK;else status=0;
 for (i=0;i<8;i++){
  for (j=0;j<8;j++){
   if (!(board[i][j] & mycolor)) continue;
   fr1.x=i;fr1.y=j;                          // find my pieces
   for (ii=0;ii<8;ii++){
    for (jj=0;jj<8;jj++){
     fr2.x=ii;fr2.y=jj;
     if ((retval1=islegal(&fr1,&fr2,MYTURN))) {swapcolor();mcount--;break;}
    }
    if (retval1) break;
   }
   if (retval1) break;
  }
  if (retval1) break;
 }
 mcount=oldmcount;
 if (retval && (!retval1)) {status=ENDE;return MATE;}
 if (!retval1) {status=ENDE;return PATT;}
 if (retval) return CHECK;
 return 0;
}
