#ifndef _RULESINCLUDED
#define _RULESINCLUDED
#define PAWN 0x01
#define KNIGHT 0x02
#define BISHOP 0x04
#define ROOK 0x08
#define QUEEN 0x10
#define KING 0x20
#define WHITEPIECE 0x40
#define BLACKPIECE 0x80
#define COLORS (BLACKPIECE |WHITEPIECE)
#define PIECES (PAWN|ROOK|KNIGHT|BISHOP|QUEEN|KING)

//special move defines
#define PROMOTE 0x01
#define PROMOTEKNIGHT 0x02
#define PROMOTEBISHOP 0x04
#define PROMOTEROOK 0x08
#define PROMOTEQUEEN 0x10

#define SHORTCASTLE 0x40
#define LONGCASTLE 0x80
#define CASTLE (SHORTCASTLE|LONGCASTLE)
#define ENPASSENT 0x100
//end special moves

#define CHECK 1
#define MATE 2
#define PATT 4
#define DRAW 8
#define RESIGN 16
#define NEWGAME 32
#define WANNA_END 64
#define ENDE (MATE|PATT|RESIGN)

#define MYTURN 1
#define OPTURN 0

typedef struct {
  int x;
  int y;
} FIELD;
#ifdef __cplusplus
extern "C" {
#endif
int islegal(FIELD *f1,FIELD *f2,int myturn);
int is_end();
void update_list(FIELD *f1,FIELD *f2);
void swapcolor();
#ifdef __cplusplus
}
#endif
#endif
